/* program vypocita odmocninu metodou tecen
   (Newtonova iteracni metoda

   x2=x1-(F(x1)/dF(x1))

   pro vypocet odmocniny plati
   F(x)=x*x - Q , kde Q je odmocnovane cislo
   pak
   x2=x1-(x1*x1-Q)/(2*x1)

*/

#include <stdio.h>
#include <math.h>

#define EPS 1E-8

double ODM(double X)
{
 double x1,x2,x3;
 if (X==0) return 0;
 x2=X;
 do {
   x1=x2;
   x3=(x1*x1-X)/(2*x1);
   x2=x1-x3;
   x3=x3/x2;
   if (x3<0) x3=-x3;
  } while (x3>EPS);
 return x2;

}


int main()
{
 double x1,q;
 q=3.0; /* odmocnovane cislo */

 x1=ODM(q);

 printf("\n%.12f odmocnina vypoctena funkci ODM ", x1);
 printf("\n%.12f odmocnina vypoctena funkci sqrt", sqrt(q));
 getchar();
 return 0;
}
  
