/* funkce na vypocet hodnoty libovolneho polynomu s koeficienty v poli
   funkce na vypocet hodnoty derivace libovolneho polynomu s koeficienty v poli
   vypocet rekurzi
*/

#include <stdio.h>

/* vypocet hodnoty obecneho polynomu, 2. varianta fce poly - rekurze */
double poly(double x, double koef[], int rad)
{
 if (rad<0) return 0;
 return koef[0]+(rad!=0)?poly(x, koef+1, rad-1)*x:0;

}

/* vypocet hodnoty 1. derivace obecneho polynomu */
double dpoly(double x, double koef[], int rad)
{
 int i;
 double pom[20];

 if ((rad<1)||(rad>20)) return 0;

 for (i=1;i<=rad;i++) pom[i-1]=i*koef[i];
 return poly(x, pom, rad-1);
}

int main()
{
 /* vypise tabulku fukce v intervalu -1..1 s krokem 0.1 */
 int i;
 double P[4]={1.0,-2.0,0.0,1.0};

 for (i=-10;i<=10;i++)
     printf("%4.1f %8.3f %8.3f\n", 0.1*i, poly(0.1*i, P, 3), dpoly(0.1*i, P, 3));

 getchar();
 return 0;

/*
   Real part      Imag part   
  4.432384e-001 -5.170794e-001
  4.432384e-001  5.170794e-001
 -1.372256e+000  0.000000e+000
 -3.142206e-001  0.000000e+000
*/

}
